package frametl;

import metadata_model_general.*;
import java.util.ArrayList;
import java.util.List;

import metadata_inventory.Environment;
import metadata_inventory.Environment.tp_environment_role;
import metadata_inventory_repository.AbstractRepositoryJDBC;

public abstract class FramETL {

	// FramETL Instancia
	private static FramETL framETL_Instance = null; 
		
	// Metadados do Inventrio
	private Environment environment_DSA = null;
	private List<Environment> environmentSource = new ArrayList<Environment>();
	private List<Environment> environmentTarget = new ArrayList<Environment>();
		
	// Metadados da modelagem dos processos
	private static List<Batch> batches = new ArrayList<Batch>();	
		
	/// Mtodos ganchos Iniciais 
	public abstract void defineMetadataInventory();	
	public abstract void defineMetadataProcess();

	
	public FramETL(boolean runProcessOnStarts) {
		super();
		
		framETL_Instance = this;
		
		System.out.println("FramETL Inicializing....");
		
		this.defineMetadataInventory();		 
		this.defineMetadataProcess();
		   
		if (runProcessOnStarts)
		   performBatches();
		
		System.out.println("FramETL Inicialized.");
	}

	
	
	
	static{	 
	}  //end first static initializer block
	
	public static FramETL getInstanceFramETL() {	
	
		return framETL_Instance;	
	}
	

	 

			 
	 
	public static void performBatches() {
			
		for (int x =0;x < batches.size();x++) {
			batches.get(x).perform();
		}			
	}
	
	
	
		
	final public Environment getEnvironment_DSA() {
		return this.environment_DSA;
	}
		
	final public Environment getEnvironmentSource(int index) {
		return environmentSource.get(index);
	}
	
	final public Environment getEnvironmentTarget(int index) {
		return environmentTarget.get(index);
	}
	
	
	
	
	final public void setInventoryEnv_DSA(Environment environment) {

		environment.setRole(tp_environment_role.STAGE);
		environment_DSA = environment;	
	}		
	final public void setInventoryEnv_DSA(String name, String definition, AbstractRepositoryJDBC repository) {
		environment_DSA = new Environment(name,definition,repository,tp_environment_role.STAGE);	
	}
	
	
	final public void addInventoryEnv_Source(Environment environment) {
		
		environment.setRole(tp_environment_role.SOURCE);
		this.environmentSource.add(environment);
		
	}	
	final public Environment addInventoryEnv_Source(String name, String definition, AbstractRepositoryJDBC repository) {
		
		this.environmentSource.add(new Environment(name,definition,repository,tp_environment_role.SOURCE));
		
		return this.environmentSource.get(this.environmentSource.size()-1);
		
	}
	
	
	final public void addInventoryEnv_Target(Environment environment) {
		
		environment.setRole(tp_environment_role.TARGET);
		this.environmentTarget.add(environment);
				
	}	
	final public  Environment addInventoryEnv_Target(String name, String definition, AbstractRepositoryJDBC repository) {
		
		this.environmentTarget.add(new Environment(name,definition,repository,tp_environment_role.TARGET));
		
		return this.environmentTarget.get(this.environmentTarget.size()-1);
	}
	
	
	final public void addBatch(Batch batch) {
		
		batches.add(batch);		
	}
	
	
	final public Batch addBatch(String name, String definition) {
		
		batches.add(new Batch(name, definition));
		
		return batches.get(this.batches.size()-1);

	}
	
	
	

}
