
package metadata_inventory_repository;

import java.sql.*;
import java.util.Properties;

import metadata_inventory_repository_common.RepositoryCsv;


public abstract class AbstractRepositoryJDBC implements Repository_Access {
	
	private String repository_name = "";
	private String user = "";
	private String password = "";
	
	private Connection conn;
	private boolean isConnected;
	
	public abstract PreparedStatement openStatement(String cSQLInsert);
	
    
    public abstract String getDriver();
    public abstract String getConnectionURL();
    
	public abstract AbstractSQLInstruction createLogicalInstruction(String table);
    	
	public AbstractRepositoryJDBC(String repositoryName,String user, String password) {		
		this.repository_name = repositoryName;
		this.password = password;
		this.user = user;	
	}
	        
	
	public void connect() {
	    
        this.setConnected(true);
       
    	try {    		
    		Class.forName(this.getDriver());
	        conn = DriverManager.getConnection(this.getConnectionURL(),this.getUser(), this.getPassword());
	        System.out.println("Conectado com sucesso em " + this.getDriver() + " !" + " url: " + this.getConnectionURL());
	    }
	    
		catch( Exception x ) {
	    	x.printStackTrace();			
	        this.setConnected(false);
	    }
	             
    }
		
	
	public ResultSet getRecordSet(String arg) {
	    Statement stmt;
        ResultSet dbresult = null;
	        
	    try{

        	if (conn == null)
        		this.connect();
        	
	         stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
	         System.out.println("query: " + arg);
	         dbresult = stmt.executeQuery(arg);
	                  
	    }
	    catch(Exception x) {
	        x.printStackTrace();
	        dbresult = null;
	        System.out.println("Erro na consulta ao banco de dados " + x.getMessage().toString());
	    }

	    return dbresult;
	}
	
	
	
	// Retorna vazio se um insert, uptdate e delete rodar ok, se n�o retorna a exce��o
	public String executeData(String query) {
        //Create Stament object
            Statement stmt;
            String reto = "";
           // this.setLast_sql(query);
            
            if (query.equalsIgnoreCase("")) {
            	System.out.println("DDL empty");
            	return "DDL empty";
            }
            
            try{
                //Execute Query
            	
            	if (conn == null)
            		this.connect();
            	
                stmt = conn.createStatement();
                
                System.out.println("runining... " + query);
                stmt.executeUpdate(query);
                
                
            }
            catch(Exception x) {
               // x.printStackTrace();
            	System.out.println("Error " + query );
                reto = x.getMessage();
            }

            return reto;
	}
	
	

	
	
	public Connection getConn() {
		return conn;
	}


	public void setConn(Connection conn) {
		this.conn = conn;
	}
	
	
	
	/*
	private boolean connectOracle() {

		try {
			
			this.driver = "oracle.jdbc.OracleDriver";
	        Class.forName(driver);
	        
	        this.connectionURL = "jdbc:oracle:thin:@" + this.getServer()+ ":" + Integer.toString(this.port) + "/" + this.getName();
	        conn = DriverManager.getConnection(getConnectionURL(),this.getUser(), this.getPassword());
	        conn.setAutoCommit(true);
	        System.out.println("Conectado com sucesso no Oracle !");
	        
	        return true;
	    }
	    
		catch( Exception x ) {
	    	x.printStackTrace();			
	        this.setConnected(false);	    	
	        return false;
	    }
	
	}
	
		
	private boolean connectFirebird() {
		
	    this.driver = "org.firebirdsql.jdbc.FBDriver";
	    
	    this.connectionURL = "jdbc:firebirdsql:" + this.getServer() + " /" + Integer.toString(this.port) + ":" + this.getName();
	    

	    // Any return from this try block will first execute the finally clause
	    // towards the bottom of this file.
	    try {

	      // Let's try to register the Firebird JCA-JDBC driver with the driver manager
	      // using one of various registration alternatives...
	      int registrationAlternative = 1;
	      switch (registrationAlternative) {

	      case 1:
	        try {
	          Class.forName (this.driver);
	          
	        }
	        catch (java.lang.ClassNotFoundException e) {
	          // A call to Class.forName() forces us to consider this exception :-)...
	          System.out.println ("Firebird JCA-JDBC driver not found in class path");
	          System.out.println (e.getMessage ());
	          return false;
	        }
	        break;
	      }}
	      
        finally {
	  	      //System.out.println ("Closing database resources and rolling back any changes we made to the database.");

  	    }
        
        
        // At this point the driver should be registered with the driver manager.
        // Try to find the registered driver that recognizes interbase URLs...
        try {
          // We pass the entire database URL, but we could just pass "jdbc:interbase:"
          Driver d = java.sql.DriverManager.getDriver (this.connectionURL);
         // System.out.println ("Firebird JCA-JDBC driver version " + d.getMajorVersion () + "." + d.getMinorVersion () + " registered with driver manager.");
        }
        catch (java.sql.SQLException e) {
          System.out.println ("Unable to find Firebird JCA-JDBC driver among the registered drivers.");         
          
          return false;
        }

        int connectionAlternative = 1;
        
        try {
           this.conn = java.sql.DriverManager.getConnection (this.connectionURL, this.getUser(), this.getPassword());                      
           System.out.println("Conectado com sucesso no Firebird !");
         }
         catch (java.sql.SQLException e) {
           System.out.println ("Unable to establish a connection through the driver manager.");
           e.printStackTrace();
           return false;
         }
         
		return false;
        		
	}
	
	*/
	
	public boolean isConnected() {
		return isConnected;
	}

	public void setConnected(boolean isConnected) {
		this.isConnected = isConnected;
	}
	

	
	    
	public boolean close(){
	try{
        conn.close();
	    return true;
	}
	catch (Exception x) {
		x.printStackTrace();
	    return false;
		}
	}
	   

	
	public ResultSet getDataSQL(String instruction) {
		
		  System.out.println("query getadata: " + instruction.toString());
		
		return this.getRecordSet(instruction); 
	}
	
	
	
	
	public PreparedStatement getStatement(String instruction) {
		
		
		return this.openStatement(instruction);
	}
	
	
	public String retornaCampodaConsultaSQL(String cSql, int indexCampo) {
	
		String cValor = "";
		ResultSet myresult = null;
		
		//System.out.println("A consulta do retorna campo foi: " + cSql);
		
		//stmt = mysql_connection.createStatement();
        //dbresult = stmt.executeQuery(query);
		
		if (cSql.equalsIgnoreCase("")) {
			return cValor;
		}
		
		//myresult = ApoloApp.getConn().query(cSql);
		
		if (myresult == null) {			
		   return cValor;
		}
		             	
    	try {
			if (myresult.getRow() == 0) {
				myresult.close();
		 	   return cValor;
			}
			
			myresult.first();
			
			cValor = myresult.getString(indexCampo);
			
			if (cValor == null)
			   cValor = "";
		        
		    myresult.close();
		     
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
		return cValor;        
        
	}
	
	
/*
	public void povoaTable(String query, String pk, Table tbl){
        //Create Stament object
    Statement stmt;
    
    String[] linha = null;
    ResultSet tmp = null;
	this.setLast_sql(query);	
	    
    try{
        	//Execute Query
         stmt = mysql_connection.createStatement();
         tmp = stmt.executeQuery(query);
         tmp.last();
         
         if ((tmp == null) || (tmp.getRow() == 0))
        	 return;
         
         int num_cols = tmp.getMetaData().getColumnCount();
         // int num_rows = tmp.getRow();

 		 tmp.first();
         // int id_line = 1;
         // int id_col = 1; 
  	    //container.addContainerProperty( modulo.getCampoConsultaPorIndex(x).getTitulo(), modulo.getCampoConsultaPorIndex(x).getTipoObj() ,null);
         // Adicionando os titulos das colunas
    	 for (int y = 1; y <= num_cols; y++) {       
    		 
    		 tbl.addContainerProperty(tmp.getMetaData().getColumnLabel(y), tmp.getMetaData().getColumnClassName(y).getClass(), null);
    		 		
    		 if ((tmp.getMetaData().getColumnClassName(y).equalsIgnoreCase("java.lang.Integer")) || (tmp.getMetaData().getColumnClassName(y).equalsIgnoreCase("java.lang.Float")))
					tbl.setColumnAlignment(tmp.getMetaData().getColumnLabel(y), Table.ALIGN_RIGHT);
    		 else
					tbl.setColumnAlignment(tmp.getMetaData().getColumnLabel(y), Table.ALIGN_LEFT);    			 
    		 // System.out.println("Nome da Coluna " + tmp.getMetaData().getColumnName(y) + " Label da Coluna : " + tmp.getMetaData().getColumnLabel(y) + " Classe da Coluna " + tmp.getMetaData().getColumnClassName(y));
    	 }
 
    	 
    	 String primeiro = "";
         do {
        	 String valuePk = "0";
     		 linha = new String[num_cols];
        	 
        	 for (int x = 1; x <= num_cols; x++) {
        		 if (tmp.getString(x) != null) {
        			 linha[x-1] = tmp.getString(x);
        			 if (pk.trim().toUpperCase().equalsIgnoreCase(tmp.getMetaData().getColumnName(x).toUpperCase())) { 
        				 valuePk =  tmp.getString(x);
        				 // para achar o primeiro registro da tabela
        				 if (primeiro.equals(""))
        					 primeiro = valuePk;
        			 }
        		 } else
        			 linha[x-1] = "";        			 
        	 }
        	 tbl.addItem(linha,valuePk);
        	 //tbl.addItem(linha, new Integer(valuePk));
        	 // id_line++;
        	 
         } while (tmp.next());
         
         tbl.select(primeiro);
         
         tmp.close();         
    }
    catch(Exception x) {
        x.printStackTrace();
    }
            
        //Return Result
        return;
    }
*/	
	

	
	/*
	public static void main(String [] args) {
		SimpleSQL conn;
		
		conn = new SimpleSQL();
                
		if (!conn.connect("192.168.1.2", "fico", "root", "Mmf@sl108")) {
			System.out.println("Não foi possivel conectar ao servidor " + conn.getServer());
		} else
		{
			System.out.println("Conectado com sucesso em " + conn.getServer());			
		}

                conn.close();
					
	}

	*/
	


    public boolean startTransaction() throws SQLException {
        boolean reto = false;
        this.conn.setAutoCommit(false);

        if (executeData("start transaction;").trim().equalsIgnoreCase(""))
            reto = true;
        return reto;
    }

    public boolean commitTransaction() throws SQLException {
        boolean reto = false;
        if (executeData("commit;").trim().equalsIgnoreCase(""))
            reto = true;
        this.conn.setAutoCommit(true);
        return reto;
    }

    public boolean rollbackTransaction() throws SQLException {
        boolean reto = false;
        if (executeData("rollback;").trim().equalsIgnoreCase(""))
            reto = true;
        this.conn.setAutoCommit(true);
        return reto;
    }
    


	
	
	public String getName() {
		return repository_name;
	}
	
	public void setName(String name) {
		this.repository_name = name;
	}
	
	public String getUser() {
		return user;
	}
	
	public void setUser(String user) {
		this.user = user;
	}
	
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}


	

    
    /**
     * @return the mysql_connectionURL
     */
	

	/*
	   public static IndexedContainer fillContainer(String sql) {
	        IndexedContainer c = new IndexedContainer();
	        fillContainer(c,sql);
	        return c;
	    }
	  */
	
    /*
   public IndexedContainer fillContainer(ObjModulo modulo) throws SQLException {
   		   
	   IndexedContainer container = new IndexedContainer();
       // System.out.println("Tamanho array " + modulo.getListaCampos().length);
       for (int x=0; x<modulo.getListaCamposConsulta().length;x++) {
    	   // System.out.println("Titulo campo " + x + " " +modulo.getCampoPorIndex(x).getTitulo() );
	        // container.addContainerProperty( modulo.getCampoPorIndex(x).getTitulo() , modulo.getCampoPorIndex(x).getTipoObj(),null);					    	   
    	   // container.addContainerProperty( modulo.getCampoConsultaPorIndex(x).getTitulo(), String.class, null);
    	   container.addContainerProperty(modulo.getCampoConsultaPorIndex(x).getTitulo(), modulo.getCampoConsultaPorIndex(x).getTipoObj() ,null);
    	       	   
       }
       
		// gridResultados.addItem(new Object[] {pedido,parceiro,cidade_dest,valor_nota,peso,volume,nota,emissao,ctrc,entrega}, new Integer(Integer.parseInt(id)));
       
       return container;
   }

   */
   

	@Override
	public void storeRecordSet() {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void createSchemaData() {
		// TODO Auto-generated method stub
		
	}    
	


}
