package metadata_inventory_repository;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import metadata_inventory.SchemaData;
import metadata_inventory.Attribute.tp_column_type;
import metadata_model_mechanism.ListOfMapper;


public abstract class AbstractSQLInstruction implements SQLSyntax {
	
	private SQLElements sqlElements = null;	
	private List<AbstractSQLInstruction> sqlElementsSecondary = new ArrayList<AbstractSQLInstruction>();
		
	public AbstractSQLInstruction(String table) {
		super();
		this.sqlElements = new SQLElements(table);
	}
	
	
	public SQLElements getSqlElements() {
		return sqlElements;
	}

	public void setSqlElements(SQLElements sqlElements) {
		this.sqlElements = sqlElements;
	}
	
	
		
	public List<AbstractSQLInstruction> getSqlElementsSecondary() {
		return sqlElementsSecondary;
	}


	public void setSqlElementsSecondary(List<AbstractSQLInstruction> sqlElementsSecondary) {
		this.sqlElementsSecondary = sqlElementsSecondary;
	}


	@Override
	public String getSelect() {
		
		return this.getSelect(true);				
	}

	
	@Override
	public String getSelect(boolean useAs, ListOfMapper  mappers) {
		
		String cSQL = "Select ";
		
	
		if (sqlElements.fields.size() > 0)
		{		   
						
			String ccampos = this.fieldstoString(useAs,useAs,mappers);
			
			System.out.println("os campos do select so " +  ccampos);
						
		    cSQL = cSQL + ccampos +  " FROM " + sqlElements.tables.get(0);		   
		}
				
		if (sqlElements.joins.size()  > 0)
			cSQL = cSQL + " " + this.jointoString();
		
		if (sqlElements.where.size()  > 0)
			cSQL = cSQL + " WHERE " + this.wheretoString();
	
		if (sqlElements.groupBy.size()  > 0)
			cSQL = cSQL + " GROUP BY " + this.groupBytoString();
	
		if (sqlElements.having.size()  > 0)
			cSQL = cSQL + " HAVING " + this.havingtoString();
						
		if (sqlElements.orderBy.size()  > 0)
			cSQL = cSQL + " ORDER BY " + this.orderBytoString();
		
		// pode est sobrecarregado pela classe especializada
		cSQL = cSQL + this.uniontoString(useAs);
						
		System.out.println("O SELECT FOI: "+cSQL);
		
		return cSQL;
	}
	
	@Override
	public String getSelect(boolean useAs) {
		
		return getSelect(useAs,null);
	}
	
	
	
	
	
	
	@Override
	public String getInsert() {
		// TODO Auto-generated method stub

		String cSQL = "Insert INTO " + this.getSqlElements().tables.get(0);
		
		if (this.getSqlElements().fields.size() > 0) {
			
			String ccampos = this.fieldstoString(false,false,null);
			
			cSQL = cSQL + " (" + ccampos + ")";
			
			System.out.println("os campos do INSERT fiels so " +  ccampos);
			
			String cparams = "";
			for (int x = 0; x < this.getSqlElements().fields.size() ;x++) {				
				if (x > 0) 
					cparams = cparams + ", ";					
				cparams = cparams + "?";
			}
			
			cSQL = cSQL + " Values (" + cparams + ")";
		}
		
		System.out.println(cSQL);
		
		return cSQL;		
	}
	
		
	@Override
	public String getInsert(ListOfMapper  mappers) {
		// TODO Auto-generated method stub

		String cSQL = "Insert INTO " + this.getSqlElements().tables.get(0);
		
		if (this.getSqlElements().fields.size() > 0) {
						
			String ccampos = this.fieldstoString(false,false,mappers);
						
			cSQL = cSQL + " (" + ccampos + ")";
			
			System.out.println("os campos do INSERT so " +  ccampos);
			
			
			String cparams = "";
			for (int x = 0; x < this.getSqlElements().fields.size() ;x++) {
				
				// em 28/01
				if (mappers.get(x).getColumn_out() == null)					
				   continue;				
				
				if ((x > 0) && (!cparams.equalsIgnoreCase(""))) 
					cparams = cparams + ", ";
				
				cparams = cparams + "?";
			}
			
			cSQL = cSQL + " Values (" + cparams + ")";
		}
		
		System.out.println(cSQL);
		
		return cSQL;		
	}
	
	
	
	


	
	
	
	@Override
	public String getDrop() {
		// TODO Auto-generated method stub
		return "DROP TABLE " + this.getSqlElements().tables.get(0); 
	}
	
	
	
	@Override
	public String fieldstoString(boolean useAs, boolean completeName, ListOfMapper  mappers) {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().fields.size() ;x++) {
			
			Field field = this.getSqlElements().fields.get(x);
			
			System.out.println("CAMPO: " + field.getFieldName().toString());
			
			// em 28/11
			if (mappers != null) {
				
				//System.out.println("ENTROUUUUUUUUUUU");
			
				if (mappers.findMapperByColIn(field.getFieldName()) != null) {
					
					// neste caso o campo do mapper serve apenas para ser usado no select
					if (mappers.findMapperByColIn(field.getFieldName()).getColumn_out() == null)					
					   continue;				
				}
				
				
			    // se o campo OUT for calculado ento no considera no create, pois ele ser incluido alter
				if (mappers.findMapperByColOut(field.getFieldAlias()) != null) 
				    if (mappers.findMapperByColOut(field.getFieldAlias()).getColumn_out().getColumn_type() == tp_column_type.VIRTUAL)					
				        continue;								
			}
			
			 			
			if ((x > 0) && (!c.equalsIgnoreCase(""))) 
		 		c = c + ", ";
			
			if (completeName)
			   c = c + this.getFieldCompleteName(field);
			else
			   c = c + field.getFieldName();
			
			if (useAs)
			if (this.getSqlElements().getFields().size() > x) {
				if (!field.getFieldAlias().equalsIgnoreCase(""))
				   c = c + " as " + field.getFieldAlias();
			}
			    
		}
		
		// em 28/01
		if (c.equalsIgnoreCase("")) {
			c = "0";
		}
		
		return c;				
	}
	

	
	
	
	@Override
	public String getFieldCompleteName(Field field) {
		// TODO Auto-generated method stub
		
		String fieldName = field.getFieldName();

		
		//  util para os casos em que o nome do campo  contem uma expresso j com o nome da tabela 
		if (!fieldName.contains("."))
			fieldName = field.getFieldTable() + "." + fieldName; 
		
				
		String fieldFunction = field.getFunction();
					
		if (!fieldFunction.equalsIgnoreCase("")) 
			fieldName = fieldFunction+"("+fieldName+")";
				
			
		return fieldName;
	}
	


	@Override
	public String jointoString() {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().joins.size() ;x++) {
							
			c = c + " " + this.getSqlElements().joins.get(x);
		}
		return c;				
	}
	
	
	@Override
	public String wheretoString() {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().where.size() ;x++) {
			
			if (x > 0) 
		 		   c = c + " AND ";
				
			c = c + this.getSqlElements().where.get(x);
		}
		return c;				
	}
	
	
	
	@Override
	public String orderBytoString() {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().orderBy.size() ;x++) {
			
			if (x > 0) 
		 		   c = c + ", ";
				
			c = c + this.getSqlElements().orderBy.get(x);
		}
		return c;				
	}
	
	
	
	
	@Override	
	public String groupBytoString() {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().groupBy.size() ;x++) {
			
			if (x > 0) 
		 		   c = c + ", ";
				
			c = c + this.getSqlElements().groupBy.get(x);
		}
		return c;				
	}
	

	
	@Override
	public String havingtoString() {
		String c = "";
		
		for (int x = 0; x < this.getSqlElements().having.size() ;x++) {
			
			if (x > 0) 
		 		   c = c + ", ";
				
			c = c + this.getSqlElements().having.get(x);
		}
		return c;				
	}
	
	
	@Override
	public String uniontoString(boolean useAs) {
		// TODO Auto-generated method stub
				
		String cSQL = "";
		
		if (this.getSqlElementsSecondary().size() > 0) {			
			for (int x = 0;x < this.getSqlElementsSecondary().size();x++) {					
				cSQL = cSQL + " UNION " + this.getSqlElementsSecondary().get(x).getSelect(useAs);
			}
		}
		
		return cSQL;		
	}
	
	
	public String getSelectAll() {
		
		return "Select * from " + sqlElements.tables.get(0);
	}
	



		

}
