package metadata_inventory_repository_common;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import metadata_inventory.Attribute;
import metadata_inventory.Attribute.tp_column_type;
import metadata_inventory.Attribute.tp_data_type;
import metadata_inventory_repository.AbstractSQLInstruction;
import metadata_model_mechanism.ListOfMapper;



public class SQLSyntaxPostgres extends AbstractSQLInstruction {

	public SQLSyntaxPostgres(String table) {
		super(table);
		// TODO Auto-generated constructor stub
	}


	@Override
	public String getSelect(int limit,boolean useAs, ListOfMapper  mappers) {
		
		return this.getSelect(useAs,mappers) + " LIMIT " + Integer.toString(limit);
	}

	@Override
	public String getCreate(String metadataSelect) {
		// TODO Auto-generated method stub
		
		// create from SELECT
		return  "CREATE TABLE IF NOT EXISTS " + this.getSqlElements().getTable(0) + " " + metadataSelect; 		
	}

	
	
	@Override
	public String getCreate(ResultSetMetaData metadataModel) {
		
		String ddl = "";
		
		String type = "";
	
		
		try {
			for (int x = 1; x <= metadataModel.getColumnCount();x++) {
				
				String columnName = metadataModel.getColumnName(x);
				
				//if (columnName.substring(0, 3) == "SEL_")
				//	continue;
				
				if (x > 1)
					ddl = ddl + ", ";
									
				//System.out.println(metadataModel.getColumnName(x) + " " + metadataModel.getColumnLabel(x) + " " + metadataModel.getColumnTypeName(x) + " " + Integer.toString(metadataModel.getColumnDisplaySize(x)) + " " + Integer.toString(metadataModel.getScale(x)) + " " + Integer.toString(metadataModel.getPrecision(x)));
								
				type = this.getTypeDBToEspecificDB(metadataModel.getColumnTypeName(x));
				
				
				
				int nScale = metadataModel.getScale(x);
				int nPrecision = metadataModel.getPrecision(x);
								
				
				if (type.toUpperCase().equalsIgnoreCase("DATETIME")) {					
					nPrecision = 0;
				}
				
				if (type.toUpperCase().equalsIgnoreCase("NUMERIC"))
				if (nScale == 0)
					type = "INT";
					
				
				if (nScale == 0) {
	
					if (nPrecision != 0)  {
						ddl = ddl + " " + columnName + " " +  type + "(" + Integer.toString(metadataModel.getPrecision(x)) + ")";
					}
					else 
					   ddl = ddl + " " + columnName + " " +  type;
				}
				else {
					
					//if (nScale > 2) {
					//	nScale = 2;
					//}
					
					
					if (nPrecision == 0)
						nPrecision = 15;
					
					ddl = ddl + " " + columnName + " " +  type + "(" + Integer.toString(nPrecision) + "," + Integer.toString(nScale) + ")";					
				}
				
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return "CREATE TABLE IF NOT EXISTS " + this.getSqlElements().getTable(0) + " ("  + ddl + ");";
				
		//System.out.println("DDL: " + this.structureDDL);
	}
	

	@Override
	public String getAlter(ListOfMapper mappers) {
		
		String ddl = "";
		
		
		for (int x = 0; x < mappers.size();x++) {
			
			String cColName = "";
			String cColType = "";
						
			Attribute colIn = mappers.get(x).getColumn_in();			
			if (colIn != null) {
			
				//SE COLUMN IN FOR CALCULADA, INDICA QUE COLUM OUT PRECISA SER CRIADA MANUALMENTE			
				if (colIn.getColumn_type() == tp_column_type.VIRTUAL) {
					
					// cria o campo com o nome da coluna OUT, mas com o tipo da columa IN
										
					cColName = mappers.get(x).getColumn_out().getName();
					cColType = this.getTypeColumnToEspecificDB(colIn);
					
				}
			}
			
			// em 28/01
			if (cColName.equalsIgnoreCase("")) {
				Attribute colOut = mappers.get(x).getColumn_out();			
				if (colOut != null) {
				
					//SE COLUMN IN FOR CALCULADA, INDICA QUE COLUM OUT PRECISA SER CRIADA MANUALMENTE			
					if (colOut.getColumn_type() == tp_column_type.VIRTUAL) {
						
						
						cColName = colOut.getName();
						cColType = this.getTypeColumnToEspecificDB(colOut);						
						
					}
				}
					
			}
			
			
			if (cColName.equalsIgnoreCase(""))
				continue;
			
						
			if (!ddl.equalsIgnoreCase(""))
				ddl = ddl + ", ";
			
			ddl = ddl + "ADD " + cColName + " " + cColType;			
		}

		
		if (!ddl.equalsIgnoreCase("")) 
			ddl = "ALTER TABLE " + this.getSqlElements().getTable(0) + " " + ddl + ";";	
		
		
		return  ddl;
		
	}


	@Override
	public String getDrop() {
		// TODO Auto-generated method stub
		return "DROP TABLE IF EXISTS " + this.getSqlElements().getTable(0); 
	}


	@Override
	public String uniontoString(boolean useAs) {
		// TODO Auto-generated method stub
				
		String cSQL = "";
		
		if (this.getSqlElementsSecondary().size() > 0) {			
			for (int x = 0;x < this.getSqlElementsSecondary().size();x++) {					
				cSQL = cSQL + " UNION ALL " + this.getSqlElementsSecondary().get(x).getSelect(useAs);
			}
		}
		
		return cSQL;		
	}


	@Override
	public String getTypeColumnToEspecificDB(Attribute column) {
		// TODO Auto-generated method stub
		
		int nSize = column.getColumn_size();
		
		String c = "";
		
		//System.out.println("tipo da coluna: " + column.getName() + column.getData_type().toString());
		
		switch (column.getData_type())  {		
			case STRING  : {
		
				if (nSize == 0)
					nSize = 250;
				
				c = "VARCHAR("+ Integer.toString(nSize)+")";
				break;				
			}
			case INTEGER : {
				
				if (nSize == 0)
					nSize = 11; 			
				
				c = "INT("+ Integer.toString(nSize)+")";
				break;
			}
			case SURROGATE_KEY : {
				
				if (nSize == 0)
					nSize = 11; 			
				
				c = "INT("+ Integer.toString(nSize)+")";
				break;
			}
			case DOUBLE  :  {
				
				if (nSize == 0)
					nSize = 15; 			
				
				c = "NUMERIC("+ Integer.toString(nSize)+",4)";
				break;
			}
			case BOOLEAN : c = "CHAR(1)"; break;	
			case DATE : c = "DATETIME"; break;
		}
				
		if (!column.getDefaultValue().equalsIgnoreCase(""))
			c = c  + " DEFAULT " + "'" + column.getDefaultValue() + "'";
		
		return c;
	}


	@Override
	public String getTypeDBToEspecificDB(String type) {
		// TODO Auto-generated method stub
		
		String ctype = type;
		
		
		if (ctype.toUpperCase().equalsIgnoreCase("NUMBER"))
			ctype = "NUMERIC";
		
		if (ctype.toUpperCase().equalsIgnoreCase("VARCHAR2"))
			ctype = "CHARACTER VARYING";
		
		if (ctype.toUpperCase().equalsIgnoreCase("VARCHAR"))
			ctype = "CHARACTER VARYING";
		
		if (ctype.toUpperCase().equalsIgnoreCase("STRING"))
			ctype = "CHARACTER VARYING";
		
		
		if (type.toUpperCase().equalsIgnoreCase("TIMESTAMP")) {
			type = "DATETIME";
		}
		
		
		return ctype;
	}



	
	
	
}




