package metadata_model_mechanism;


import java.util.ArrayList;
import java.util.List;

import metadata_inventory.Attribute;
import metadata_inventory.SchemaData;
import metadata_model_general.Job;


public abstract class AbstractMechanismNary extends AbstractMechanism {

	private tp_transfNary type;

	public static enum tp_transfNary {
    	PRIMARYFLOW, COMBINATOR
    }
	
	public AbstractMechanismNary(Job jobOwner, String name, String definition,AbstractMechanism transfMainInput, AbstractMechanism transfSecondaryInput) {
		super(jobOwner, name, definition, transfMainInput);
		
		//this.getRecordSetInput().setSchema2(transfSecondaryInput.getRecordSetOutput().getSchema());
		this.addTransfInput(transfSecondaryInput);
				
		// TODO Auto-generated constructor stub
	}
	
	public AbstractMechanismNary(Job jobOwner, String name, String definition,AbstractMechanism transfMainInput, AbstractMechanism transfSecondaryInput, SchemaData schemaOut) {
		super(jobOwner, transfMainInput, schemaOut);
		
		//this.getRecordSetInput().setSchema2(transfSecondaryInput.getRecordSetOutput().getSchema());
		this.addTransfInput(transfSecondaryInput);
				
		// TODO Auto-generated constructor stub
	}
	
	
	public AbstractMechanismNary(Job jobOwner, String name, String definition,SchemaData schema1In, SchemaData schema2In) {
		super(jobOwner, name, definition, schema1In, null);
		
		this.getRecordSetInput().addSchema(schema2In);
		// TODO Auto-generated constructor stub
	}
	
	
	public AbstractMechanismNary(Job jobOwner, String name, String definition,SchemaData schema1In, SchemaData schema2In, SchemaData schemaOut) {
		super(jobOwner, name, definition, schema1In, schemaOut);
		
		this.getRecordSetInput().addSchema(schema2In);
		// TODO Auto-generated constructor stub
	}
	
	public void addTransfInput(AbstractMechanism transf) {
		
		super.addTransfInput(transf);
		
	}
	
	

	
	@Override
	final public boolean identifyInputColumns() {

		// considera nome dos campos de todos os intputs
		if (this.getType().equals(tp_transfNary.PRIMARYFLOW)) 
			this.addInputColumnsFromInventaryOrTransf();   // OBS USA O METODO DE THIS
				
		// considera nome dos campos apenas do primeiro input
		if (this.getType().equals(tp_transfNary.COMBINATOR)) 
			super.addInputColumnsFromInventaryOrTransf();  // OBS USA O METODO DE SUPER
				
		// mario domingo de carnaval
		//if (this.mappers.size() == 0) {	
			this.addMappersFromInputColumns();
		//}
			
		
		// preenche sqlgenarator com todos os nomes de tabela
		if (this.getType().equals(tp_transfNary.PRIMARYFLOW)) {
			this.getRecordSetInput().setSqlGenerator("");			
			this.getRecordSetInput().getSqlGenerator().getSqlElements().addTables(this.getSchemasInput());
			
			this.getRecordSetInput().getSqlGenerator().getSqlElements().addFields(this.mappers,true);
		}
		
		// preenche sqlgenarator apenas com o nome da primeira tabela
		if (this.getType().equals(tp_transfNary.COMBINATOR)) {			
			this.getRecordSetInput().setSqlGenerator(this.getSchemasInput().get(0).getName());
			
			this.getInputSqlElements().addFields(this.mappers,true);
			
			
			// inclui os demais inputus com seus respectivos selects (que sero os unions) OBSERVAR APARTIR DO INDICE 1
			for (int x = 1;x < this.getSchemasInput().size();x++) {			
				this.getInputSecondaryStatements().add(this.getRecordSetInput().createSqlSyntax(this.getSchemaInput(x).getName()));
				
		    	this.getInputSecondaryStatements().get(x-1).getSqlElements().addFields(this.mappers,false);
			}
			
		}		
				
		return false;		
	}
	
	
	public void addInputColumnsFromInventaryOrTransf() {
		
	    List<Attribute> columns = null;
	    		    
	    // para os casos das transformaes que consideram os campos de todos os inputs (ex.: JOIN)
	    
		columns = new ArrayList<Attribute>(); 
		
		
		if (this.getTransfInput().size() > 0) {
							
			for (int x = 0;x < this.getTransfInput().size();x++) {
				
				for (int y = 0;y < this.getTransfInput().get(x).getRecordSetOutput().getColumns().size();y++) {
					
					Attribute col = this.getTransfInput().get(x).getRecordSetOutput().getColumns().get(y);
					
					//System.out.println(col.getName() + " nome do output: " + this.getTransfInput().get(x).getRecordSetOutput().getSchemaData().getName());
					
					columns.add(new Attribute(col.getName(),this.getTransfInput().get(x).getRecordSetOutput().getSchemaData(),col.getData_type()));
				}					
			}
		}
		    
		else if (this.getRecordSetInput().getSchema(0) != null) {
			
			for (int x = 0;x < this.getRecordSetInput().getSchemasData().size();x++) {
				
				for (int y = 0;y < this.getRecordSetInput().getSchema(x).getColumns_Inventory().size();y++) {
					
					Attribute col = this.getRecordSetInput().getSchema(x).getColumns_Inventory().get(y);
				
					columns.add(new Attribute(col.getName(),this.getRecordSetInput().getSchema(x),col.getData_type()));
				}
			}
		}
		
		this.getRecordSetInput().setColumns(columns);
							
	}
	

	public tp_transfNary getType() {
		return type;
	}

	public void setType(tp_transfNary type) {
		this.type = type;
	}
	
	
	

	

	
	
	
	

}
