package metadata_model_mechanism;

import java.util.ArrayList;
import java.util.List;

import metadata_inventory.Attribute;
import metadata_inventory.Attribute.tp_column_type;

public class ListOfMapper {
	
	public List<Mapper> mappers = new ArrayList<Mapper>();	
		
	public int size() {
		
		return this.mappers.size();
	}
	
	
	public void add(Attribute data_in, Attribute column_out) {
		
		Mapper map = new Mapper(data_in, column_out);
		
		this.mappers.add(map);		
	}
	
	
	public void add(Attribute data_in, Attribute column_out, Params conversionParam) {
		
		Mapper map = new Mapper(data_in, column_out,conversionParam);
		
		this.mappers.add(map);		
	}
	
	

	public Mapper get(int index) {
		return this.mappers.get(index);
	}
	
	
	public Mapper findMapperByColOut(String columnOutName) {
		
		for (int x =0;x < this.mappers.size();x++) {
			
			// em 28/01
			if (this.mappers.get(x).getColumn_out() == null) {
				continue;
			}
			
			if (this.mappers.get(x).getColumn_out().getName().equalsIgnoreCase(columnOutName))
				return this.mappers.get(x);			
			
		}
				
		return null;				
	}
	
	
	public Attribute getColumnOutByName(String colName) {
		
		Mapper map = findMapperByColOut(colName);
		
		if (map != null) {
		
			return map.getColumn_out();
		}
		else
			System.out.println("Coluna out no encontrada: " + colName); 
		
		return null;
		
	}
	
	
	
	
	
	public Mapper findMapperByColIn(String columnInName) {
		
		for (int x =0;x < this.mappers.size();x++) {
			
			// em 28/01
			if (this.mappers.get(x).getColumn_in() == null) {
				continue;
			}
			
			if (this.mappers.get(x).getColumn_in().getName().equalsIgnoreCase(columnInName))
				return this.mappers.get(x);			
			
		}
				
		return null;				
	}
	
	
	public Attribute getColumnInByName(String colName) {
		
		return findMapperByColIn(colName).getColumn_in();
	}
	


}
