package metadata_model_mechanisms_common;

import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.*;

import bsh.Interpreter;



import frametl.FramETL;
import metadata_inventory.Attribute;
import metadata_inventory.SchemaData;
import metadata_inventory.Attribute.tp_column_type;
import metadata_inventory_repository.SQLElements;
import metadata_model_general.Job;
import metadata_model_mechanism.AbstractMechanism;
import metadata_model_mechanism.AbstractMechanismUnary;
import metadata_model_mechanism.ListOfMapper;
import metadata_model_mechanism.Mapper;
import metadata_model_mechanism.Params;
import metadata_model_mechanism.RowControl;
import metadata_model_mechanism.RowControl.tp_flow_sequence;
import metadata_model_mechanism.RowControl.tp_status;

public class Conversion extends AbstractMechanismUnary {
	



	public Conversion(Job jobOwner, String name,String definition, AbstractMechanism transInput) {
		super(jobOwner, name, definition, transInput);
		// TODO Auto-generated constructor stub
	}


	public Conversion(FramETL framEtl, Job jobOwner, AbstractMechanism transInput) {
		super(jobOwner, "", "", transInput);
		// TODO Auto-generated constructor stub
	}

	
	
	public  Conversion(FramETL framEtl, Job jobOwner, String name,String definition) {
		super(jobOwner, name, definition);
				
		// TODO Auto-generated constructor stub
	}



	public static enum function_string {
    	CONCAT, REPLACE, SUBSTR, TRIM, ALLTRIM, UPPERCASE, LOWCASE, PAD    
    }
	
	public static enum function_arithmetic {
    	DEC, INT, ROUND, EXPRESSION
    }
		
	public static enum tp_convertion {
    	STRING, ARITHMETIC, LOOKUP
    }
	
	
	
	
	public Mapper addMapper(Params myparam, Attribute column_out) {
		
		// se ja tiver no inclui de novo
	//	if (!allowRepeateddOut)
			
		Mapper map = null;
		
		// adiciona os maperadores para cada campo dos parametros, apenas para que sejam trazidos na query
		
		if (myparam.getItem(1).equalsIgnoreCase(function_string.CONCAT.toString())  || myparam.getItem(1).equalsIgnoreCase(function_string.REPLACE.toString()) || myparam.getItem(1).equalsIgnoreCase(function_arithmetic.EXPRESSION.toString()))
		for (int x =2;x < myparam.getItens().size() ;x++) {
			
			String cItem = myparam.getItem(x);
			
			if (!cItem.contains("'") && !cItem.contains("$")) {
				
				String cColName = cItem;
				
				map = mappers.findMapperByColOut(cColName);
				
				if (map != null)
				   continue;
				
				Attribute col = new Attribute(cColName,this.getRecordSetInput(),column_out.getData_type());
								
				//comecar aqui, quando monta o as do sql verificar se tem conversionPAram se houver no usa o column_out e sim o  in
				
				mappers.add(col,null);
				
			}
			
		}
		
		
		// adiciona o maperador para o campo a ser CONVERTIDO o qual ter o parametro de "conversao" associado 
		mappers.add(column_out,column_out,myparam);					
        map = mappers.get(mappers.size()-1);	
        
        System.out.println("INCLIU mapper: " + column_out.getName() + " " + myparam.getItem(1).toString());
	
		
		return map;

	}
	
	

	public Mapper addMapper(Params conversionParam, Attribute column_in, Attribute column_out) {
		
		// se ja tiver no inclui de novo
	//	if (!allowRepeateddOut)
			
		Mapper map = null;
	 
		this.getMappers().add(column_in,column_out,conversionParam);					
        map = this.getMappers().get(this.getMappers().size()-1);	
		
		return map;

	}
	
	
	public Params addParamConcat(String fieldsCSV) {			
		Params param = new Params();
		String[] A;
		
		A = fieldsCSV.split(",");
		
		param.addItem(tp_convertion.STRING.toString());		
		param.addItem(function_string.CONCAT.toString());
		
		for (int x =0;x < A.length;x++) {
			param.addItem(A[x]);	
		}
		
		this.addParam(param);
		
		return param;		
	}
	
	public Params addParamReplace(String strOriginal, String replaceTo) {			
		Params param = new Params();
				
		param.addItem(tp_convertion.STRING.toString());		
		param.addItem(function_string.REPLACE.toString());
		   	    	
   	    param.addItem(strOriginal);
   	    param.addItem(replaceTo);
		
		this.addParam(param);
		return param;		
	}
	
	public Params addParamSubStr(String indexFrom, String IndexTo) {			
		Params param = new Params();
				
		param.addItem(tp_convertion.STRING.toString());		
		param.addItem(function_string.SUBSTR.toString());
		   	    	
   	    param.addItem(indexFrom);
   	    param.addItem(IndexTo);
		
		this.addParam(param);
		return param;		
	}
	
	
	public Params addParamPAD(String cChar, String tamanho) {			
		Params param = new Params();
				
		param.addItem(tp_convertion.STRING.toString());		
		param.addItem(function_string.PAD.toString());
		   	    	
   	    param.addItem(cChar);
   	    param.addItem(tamanho);
		
		this.addParam(param);
		return param;		
	}
	
	
	public Params addParamArithmetic_Dec() {			
		Params param = new Params();
				
		param.addItem(tp_convertion.ARITHMETIC.toString());		
		param.addItem(function_arithmetic.DEC.toString());
		
		this.addParam(param);
		
		return param;		
	}
	
	
	public Params addParamArithmetic_Int() {			
		Params param = new Params();
			
		param.addItem(tp_convertion.ARITHMETIC.toString());		
		param.addItem(function_arithmetic.INT.toString());
		
		this.addParam(param);
		
		return param;		
	}
	
	public Params addParamArithmetic_Round() {			
		Params param = new Params();
			
		param.addItem(tp_convertion.ARITHMETIC.toString());		
		param.addItem(function_arithmetic.ROUND.toString());
		
		this.addParam(param);
		
		return param;		
	}
	
	
	
	public Params addParamArithmetic_Expression(String expression) {			
		Params param = new Params();
				
		param.addItem(tp_convertion.ARITHMETIC.toString());		
		param.addItem(function_arithmetic.EXPRESSION.toString());
		param.addItem(expression);
				
		String ctmp = expression;
		
		while (ctmp.contains("$")) {
			
			int nstart = ctmp.indexOf("$");
			int nend = ctmp.indexOf(" ",nstart);
			
			if (nend == -1)
				nend = ctmp.length();
						
			String cfield = ctmp.substring(nstart+1, nend);		
			param.addItem(cfield);		
			ctmp = ctmp.replace(ctmp.substring(nstart, nend), "");
				
		}
		
		
		return param;		
	}
	
	
		
	
	
	//CONCAT, REPLACE, SUBSTR, TRIM, ALLTRIM, UPPERCASE, LOWCASE, PAD   
		

	@Override
	public void onOpenDataSet() {
			

	}
	
	

	@Override
	public void init() {
		// TODO Auto-generated method stub
		
	

	}

	@Override
	public void onFinish(AbstractMechanism transf) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStart(AbstractMechanism transf) {
		// TODO Auto-generated method stub
		
	}

	
	
	@Override
	public void forEachInputtRow(ListOfMapper mappers, RowControl rowControl) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onMapping(Mapper currentMap) {
		// TODO Auto-generated method stub
		Params param = currentMap.getConversionParam();
		
		if (param != null) {
				
			String cValue = "";
			
			
			if (param.getItem(1).equalsIgnoreCase(function_string.CONCAT.toString())) {
				
							
				for (int x = 2;x < param.getItens().size() ;x++) {
					
					String cItem = param.getItem(x);				
				    
				//	System.out.println("campos a concatenar: " + cItem);
													
					if (!cItem.contains("'")) {						
						//String cColName = cItem.replaceAll("C#", "");
						String cColName = cItem;
												
						Attribute col = null;
						Mapper mapField = null;
						
						mapField = mappers.findMapperByColIn(cColName);
						if (mapField != null)
						    col = mapField.getColumn_in();
						else {
							mapField = mappers.findMapperByColOut(cColName);							
							col = mapField.getColumn_out();								
						}
							
						
						cValue = cValue + col.getData_value();					
					}
					else
						cValue = cValue + cItem.replaceAll("'", "");
					
				}				
			}
			
			
			if (param.getItem(1).equalsIgnoreCase(function_string.REPLACE.toString())) {
				
				String strOriginal = param.getItem(2);
				String strReplaceTo = param.getItem(3);
				
				//System.out.println("substituir: " + strOriginal + " por " + strReplaceTo);				
				//System.out.println("original: " + map.getColumn_out().getData_value());
												
				if (!strReplaceTo.contains("'")) {					
					String cColName = strReplaceTo;
					
					Attribute col = null;
					Mapper mapField = null;
					
					mapField = mappers.findMapperByColIn(cColName);
					if (mapField != null)
					    col = mapField.getColumn_in();
					else {
						mapField = mappers.findMapperByColOut(cColName);							
						col = mapField.getColumn_out();								
					}
					
					strReplaceTo = col.getData_value();					
				} 
				else  {
					strReplaceTo = strReplaceTo.replaceAll("'", "");					
				}
				
				strOriginal = strOriginal.replaceAll("'", "");
								
				cValue = currentMap.getColumn_out().getData_value().replaceAll(strOriginal, strReplaceTo);
			}
			
			
			if (param.getItem(1).equalsIgnoreCase(function_string.SUBSTR.toString())) {
				
				String indexFrom = param.getItem(2);
				String indexTo = param.getItem(3);
				
				//System.out.println("valor orign " + map.getColumn_out().getData_value());
							
				cValue = currentMap.getColumn_out().getData_value().substring(Integer.parseInt(indexFrom), Integer.parseInt(indexTo)); 
												
			}
			
			
			if (param.getItem(1).equalsIgnoreCase(function_string.TRIM.toString())) {
											
				cValue = currentMap.getColumn_out().getData_value().trim(); 
												
			}
			
			if (param.getItem(1).equalsIgnoreCase(function_string.PAD.toString())) {				
				String cChar = param.getItem(2);
				String tamanho = param.getItem(3);
				
				//cValue = String.format("%" + cChar + tamanho + "d", Integer.parseInt(map.getColumn_out().getData_value()));
				
				// isto  so um teste
				cValue = String.format("%" + cChar + tamanho + "d", Integer.parseInt(currentMap.getColumn_in().getData_value()));
								
				//System.out.println("o pad foi: " + cValue);
				
			}
	
			if (param.getItem(1).equalsIgnoreCase(function_string.TRIM.toString())) {				
				cValue = currentMap.getColumn_out().getData_value().trim(); 												
			}

			if (param.getItem(1).equalsIgnoreCase(function_string.UPPERCASE.toString())) {				
				cValue = currentMap.getColumn_out().getData_value().toUpperCase(); 												
			}

			if (param.getItem(1).equalsIgnoreCase(function_string.LOWCASE.toString())) {				
				cValue = currentMap.getColumn_out().getData_value().toLowerCase(); 												
			}
			
			
			if (param.getItem(1).equalsIgnoreCase(function_arithmetic.INT.toString())) {
				
				try {
				   cValue = Double.toString(Math.floor(Double.parseDouble(currentMap.getColumn_out().getData_value())));
								
				} catch (Exception e) {
					// TODO Auto-generated catch block 
					//e.printStackTrace();
					System.out.println("Erro conversion mechanism : " + e.toString());
				}
			}
			
			if (param.getItem(1).equalsIgnoreCase(function_arithmetic.ROUND.toString())) {
				
				try {
				   cValue = Double.toString(Math.round(Double.parseDouble(currentMap.getColumn_out().getData_value())));
								
				} catch (Exception e) {
					// TODO Auto-generated catch block 
					//e.printStackTrace();
					System.out.println("Erro conversion mechanism : " + e.toString());
				}
			}
			
			if (param.getItem(1).equalsIgnoreCase(function_arithmetic.DEC.toString())) {
				
				try {					
					double value = Double.parseDouble(currentMap.getColumn_out().getData_value());
					double fractionalPart = value % 1; // resto da diviso de inteiro															
				    cValue = Double.toString(fractionalPart);
								
				} catch (Exception e) {
					// TODO Auto-generated catch block 
					//e.printStackTrace();
					System.out.println("Erro conversion mechanism : " + e.toString());
				}
			}
			
			
			if (param.getItem(1).equalsIgnoreCase(function_arithmetic.EXPRESSION.toString())) {
				
				try {					
					
					Interpreter bshInterpreter = new Interpreter(); 
					
					String exp = param.getItem(2);
										
					for (int x = 0; x < mappers.size();x++) {
					
						Attribute col = null;												
						col = mappers.get(x).getColumn_in();						
						if (col == null)
						    col = mappers.get(x).getColumn_out();
														
						exp = exp.replace("$"+col.getName(), col.getData_value());					
					}
					
					//System.out.println("EXPRESSAO: " + exp);
																
					cValue = bshInterpreter.eval(exp).toString();
								
				} catch (Exception e) {
					// TODO Auto-generated catch block 
					//e.printStackTrace();
					System.out.println("Erro conversion mechanism : " + e.toString());
				}
			}
					
	
			currentMap.getColumn_out().setData_value(cValue);
		}
			
	}


	
	/*public class Evaluate {
    public static void main(String[] args) { 
        Stack<String> ops  = new Stack<String>();
        Stack<Double> vals = new Stack<Double>();

        while (!StdIn.isEmpty()) {
            String s = StdIn.readString();
            if      (s.equals("("))               ;
            else if (s.equals("+"))    ops.push(s);
            else if (s.equals("-"))    ops.push(s);
            else if (s.equals("*"))    ops.push(s);
            else if (s.equals("/"))    ops.push(s);
            else if (s.equals("sqrt")) ops.push(s);
            else if (s.equals(")")) {
                String op = ops.pop();
                double v = vals.pop();
                if      (op.equals("+"))    v = vals.pop() + v;
                else if (op.equals("-"))    v = vals.pop() - v;
                else if (op.equals("*"))    v = vals.pop() * v;
                else if (op.equals("/"))    v = vals.pop() / v;
                else if (op.equals("sqrt")) v = Math.sqrt(v);
                vals.push(v);
            }
            else vals.push(Double.parseDouble(s));
        }
        StdOut.println(vals.pop());
    }
}
*/
	

	

/*

	@Override
	public String onMapping(Mapper map, String dataValue) {
		
		//System.out.println("CAMPO: " + map.getColumn_out().getName());
		
		
		if (map.getColumn_out().getName().equalsIgnoreCase("novo")) {
			
			System.out.println("ORGINAL: " + dataValue);
			
			return "COD" + Integer.toString(nconta);
			
		}
		
				
		// TODO Auto-generated method stub
		return null;
	}

	*/

	



}
