package processETL_DWSales;

import frametl4StarDW.*;



import metadata_inventory.*;
import metadata_inventory_repository_common.RepositoryCsv;
import metadata_inventory_repository_common.RepositoryMySql;
import metadata_inventory_repository_common.RepositoryOracle;
import metadata_model_general.Batch;
import metadata_model_general.Job;
import metadata_model_mechanism.Params;
import metadata_model_mechanisms_common.*;



public class DWSales extends FrametlStarDW {
		
	public DWSales(boolean runProcessOnStarts) {
		super(runProcessOnStarts);
		// TODO Auto-generated constructor stub
	}




	public static void main(String[] args) {
		// TODO Auto-generated method stub
			
		System.out.println("App Main");			
		new DWSales(true);				
			
	}
	


	
	@Override
	public void defineMetadataInventory() {
		// TODO Auto-generated method stub
		
				
		// Environments  
		
		System.out.println("Defining Metadata Inventory....");
		
		RepositoryCsv repositoryCsv = new RepositoryCsv("D:\\Pessoal\\Mestrado\\Dissertacao\\casos\\DWStarSchema\\",";","csv");	
	
		RepositoryMySql repositoryMysqlSource = new RepositoryMySql("localhost","serra_branca","root", "123");			
		RepositoryMySql repositoryMysql = new RepositoryMySql("localhost","frametl_dsa","root", "123");				
		RepositoryOracle repositoryOracle = new RepositoryOracle("localhost", "XE", "mariosergio", "123456");	
		
		
		// DSA Environment
	    this.setInventoryEnv_DSA("EnvDSA","Area de processamento de Dados",repositoryMysql);		
		
	    // Sources Environment	    
	    metadata_inventory.Environment envSourceCsv = this.addInventoryEnv_Source("EnvSourceCsv","Uma Fonte de Dados",repositoryCsv);
	    
	    Environment envSourceMySql = this.addInventoryEnv_Source("EnvSourceFB","Uma Fonte de Dados",repositoryMysqlSource);	    

	    
	    // Target Environment
		Environment envTargetOracle = this.addInventoryEnv_Target("EnvTargOra"," Destino dos dados",repositoryOracle);
				
		
		
		
		// Source Schemas  
		
		SchemaData schData = null;
	  		
		schData = envSourceCsv.addSchemaData(new SchemaData("TabelaTempo","Tempo","Tabela Tempo"));
		
		schData.addColumn_Inventory("DATA");
		schData.addColumn_Inventory("DIA");		
		schData.addColumn_Inventory("ANO");
		schData.addColumn_Inventory("SEMANA");
		schData.addColumn_Inventory("DIAS");
		schData.addColumn_Inventory("TIPO_DIA");
		schData.addColumn_Inventory("DIA_DA_SEMANA");
		schData.addColumn_Inventory("E_ULTIMO_DIA_MES");
		schData.addColumn_Inventory("MES");
		schData.addColumn_Inventory("TRIMESTRE");
		schData.addColumn_Inventory("SEMESTRE");
		schData.addColumn_Inventory("MES_EXTENSO");
		
		
		schData = envSourceMySql.addSchemaData(new SchemaData("es001","Produto","Cadastro de Produtos"));
		schData.addColumn_Inventory("CODIGO","produto_cod_pk");
		schData.addColumn_Inventory("DESCRICAO","produto_nome");
		schData.addColumn_Inventory("es004_ID","tipo_cod_fk");
		schData.addColumn_Inventory("es007_ID","categoria_cod_fk");
		schData.addColumn_Inventory("es010_ID","embalagem_cod_fk");
		
		
		schData = envSourceMySql.addSchemaData(new SchemaData("es004","Produto_tipo","Cadastro de Tipo de Produtos"));
		schData.addColumn_Inventory("ID","produto_tipo_pk");
		schData.addColumn_Inventory("DESCRICAO","tipo_descricao");
		
		schData = envSourceMySql.addSchemaData(new SchemaData("es007","Produto_categoria","Cadastro de Categoria de Produtos"));
		schData.addColumn_Inventory("ID","categoria_tipo_pk");
		schData.addColumn_Inventory("DESCRICAO","categoria_descricao");
		schData.addColumn_Inventory("ES022_ID","subcategoria_id");
		
		schData = envSourceMySql.addSchemaData(new SchemaData("es022","Produto_Subcategoria","Cadastro de SubCategoria de Produtos"));
		schData.addColumn_Inventory("ID","categoria_tipo_pk");
		schData.addColumn_Inventory("DESCRICAO","subcategoria_descricao");
		
		
		
		schData = envSourceMySql.addSchemaData(new SchemaData("es010","Produto_embalagem","Cadastro de Embalagem de Produtos"));
		schData.addColumn_Inventory("ID","embalagem_tipo_pk");
		schData.addColumn_Inventory("DESCRICAO","embalagem_descricao");
		
		
		
		schData = envSourceMySql.addSchemaData(new SchemaData("tb001","Cliente","Cadastro de Clientes"));
		schData.addColumn_Inventory("ID","cliente_cod_pk");
		schData.addColumn_Inventory("CPF_CNPJ","cnpj");
		schData.addColumn_Inventory("NOME_FANTASIA","cliente_nome");
		
		
		schData = envSourceMySql.addSchemaData(new SchemaData("cv001","Pedido","Movimento de Pedidos"));
		schData.addColumn_Inventory("PEDIDO","pedido_cod_pk");
		schData.addColumn_Inventory("TB001_ID","cliente_id");
		schData.addColumn_Inventory("DATA","DATA");	
		
		schData = envSourceMySql.addSchemaData(new SchemaData("cv002","PedidoItens","Itens de Pedido"));
		schData.addColumn_Inventory("CV001_PEDIDO","pedido_cod_fk");
		schData.addColumn_Inventory("ES001_CODIGO","produto_cod_fk");
		schData.addColumn_Inventory("QUANTIDADE_ATENDIDO","qtd");
		schData.addColumn_Inventory("PESO_TOTAL_ATENDIDO","peso");
		schData.addColumn_Inventory("VALOR_TOTAL_ATENDIDO","valor");
		schData.addColumn_Inventory("DESCONTO","desconto");
		schData.addColumn_Inventory("VALOR_TOTAL","valor_total");
		
		///////////////////
				
		
		
		
		// Target Schemas	

	    envTargetOracle.addSchemaData(new SchemaData("DIM_TEMPO","Dim_Tempo","Dimenso Tempo"));	
		
		envTargetOracle.addSchemaData(new SchemaData("DIM_CLIENTE","Dim_Cliente","Dimenso Clientes"));		
		envTargetOracle.addSchemaData(new SchemaData("DIM_PRODUTO","Dim_Produto","Dimenso de Produtos"));		
		envTargetOracle.addSchemaData(new SchemaData("FACT_VENDA_ITENS","Fact_Venda","Tabela de Itens de Venda"));	
  
		
		
  
		
	}
	

	@Override
	public void defineMetadataProcess() {
		// TODO Auto-generated method stub
				
		System.out.println("Defining Metadata ETL....");
				
		// Create Batch
        Batch mybatch = this.addBatch("btc_1","Batch one");
                   
        

		// <<<<<<<<<<<<<<<  Create Job 1 Loading from Csv >>>>>>>>>>>>>>>>>>>
		Job myjob1 = mybatch.addJob("JOB_1","ETL DW",this.getEnvironmentSource(0),this.getEnvironmentTarget(0));		
		Extractor extractTempo = new Extractor(myjob1,"Tempo");
		extractTempo.createSurrogateKey();
		
			
		
        
		// <<<<<<<<<<<<<<<  Create Job 2 Loading from Mysql >>>>>>>>>>>>>>>>>>>
		Job myjobETLDW = mybatch.addJob("JOB_2","ETL DW",this.getEnvironmentSource(1),this.getEnvironmentTarget(0));		
		
		
		
		// define transformations
		
		// >>>>> EXTRACTS		 		
		Extractor extractProd = new Extractor(myjobETLDW,"Produto"); // registros: 76
		extractProd.createSurrogateKey();
		
		
		Extractor extractProdTipo = new Extractor(myjobETLDW,"Produto_Tipo");	// registros: 5	
		Extractor extractProdEmbalagem = new Extractor(myjobETLDW,"Produto_Embalagem"); // registros: 48 
		Extractor extractProdCategoria = new Extractor(myjobETLDW,"Produto_Categoria"); // registros: 14 
		Extractor extractProdSubCategoria = new Extractor(myjobETLDW,"Produto_SubCategoria"); // registros: 3
		
		
		
		Extractor extractClient = new Extractor(myjobETLDW,"Cliente"); // registros: 383
		extractClient.createSurrogateKey();
				
		
		Extractor extractPedidos = new Extractor(myjobETLDW,"Pedido");	// registros: 724			
		Extractor extractVendas = new Extractor(myjobETLDW,"PedidoItens"); // registros: 1196

		
		// >>>>>>>> JOINS		
		Join joinVendPed = new Join(myjobETLDW,extractPedidos,extractVendas);		
		joinVendPed.setParam("pedido","cv001_pedido");
		
				
		// >>>>>> LOADS 3 DW DIMENSIONS
		
		// Dimension Product
		
		
		// <<<<<<<<<<<<<<<  Create Job Loading from Mysql to Oracle >>>>>>>>>>>>>>>>>>>
		
		LoaderStarSchema_Dimension load_DimProduct = new LoaderStarSchema_Dimension(myjobETLDW,extractProd,"Dim_Produto", "DIM_PRODUTO_SK");
			
		load_DimProduct.addParamTableSource(extractProdTipo, "id", "es004_id");
		load_DimProduct.addParamTableSource(extractProdEmbalagem, "id", "es010_id");
		load_DimProduct.addParamTableSource(extractProdCategoria, "id", "es007_id");
		load_DimProduct.addParamTableSource(extractProdSubCategoria, "id", extractProdCategoria, "es022_id");
				
		load_DimProduct.addMapperAttribute("CODIGO","CODIGO");
		load_DimProduct.addMapperAttribute("DESCRICAO","DESCRICAO");
		
		load_DimProduct.addMapperAttribute(extractProdTipo,"DESCRICAO","TIPO");	
		load_DimProduct.addMapperAttribute(extractProdEmbalagem,"DESCRICAO","EMBALAGEM");
		load_DimProduct.addMapperAttribute(extractProdCategoria,"DESCRICAO","CATEGORIA");		
		load_DimProduct.addMapperAttribute(extractProdSubCategoria,"DESCRICAO","SUBCATEGORIA");
		
		
		/*
		Params paramTipo   = load_DimProduct.addParamTableSource("Produto_Tipo", "id", "es004_id");
		Params paramEmbal  = load_DimProduct.addParamTableSource("Produto_Embalagem", "id", "es010_id");
		Params paramCat    = load_DimProduct.addParamTableSource("Produto_Categoria", "id", "es007_id");
		Params paramSubCat = load_DimProduct.addParamTableSource("Produto_SubCategoria", "id", "Produto_Categoria", "es022_id");
				
		load_DimProduct.addMapperAttribute("CODIGO","CODIGO");
		load_DimProduct.addMapperAttribute("DESCRICAO","DESCRICAO");
		load_DimProduct.addMapperAttribute(paramTipo.getMechanism(),"DESCRICAO","TIPO");	
		load_DimProduct.addMapperAttribute(paramEmbal.getMechanism(),"DESCRICAO","EMBALAGEM");
		load_DimProduct.addMapperAttribute(paramCat.getMechanism(),"DESCRICAO","CATEGORIA");		
		load_DimProduct.addMapperAttribute(paramSubCat.getMechanism(),"DESCRICAO","SUBCATEGORIA");
		*/
		
					
		// Dimension Client
		LoaderStarSchema_Dimension load_Dim2 = new LoaderStarSchema_Dimension(myjobETLDW,extractClient,"Dim_Cliente", "DIM_CLIENTE_SK");
		load_Dim2.addMapperAttribute("NOME_FANTASIA","NOME");
		load_Dim2.addMapperAttribute("CPF_CNPJ","CNPJ");
		
		
		
		// Dimension Time
		LoaderStarSchema_Dimension load_DimTempo = new LoaderStarSchema_Dimension(myjobETLDW, extractTempo,"Dim_Tempo", "DIM_TEMPO_SK");
		load_DimTempo.addMapperAttribute("DATA");
		load_DimTempo.addMapperAttribute("DIA");		
		load_DimTempo.addMapperAttribute("ANO");
		load_DimTempo.addMapperAttribute("MES");
		load_DimTempo.addMapperAttribute("SEMANA");		
		load_DimTempo.addMapperAttribute("DIAS");
		load_DimTempo.addMapperAttribute("TIPO_DIA");
		load_DimTempo.addMapperAttribute("DIA_DA_SEMANA");
		load_DimTempo.addMapperAttribute("E_ULTIMO_DIA_MES");
		load_DimTempo.addMapperAttribute("TRIMESTRE");
		load_DimTempo.addMapperAttribute("SEMESTRE");
		load_DimTempo.addMapperAttribute("MES_EXTENSO");
		load_DimTempo.addCustomHandler(new ScriptDataFormat());
			
		
		//  LOAD 1 DW FACTS
		
		LoaderStarSchema_Fact load_Fact = new LoaderStarSchema_Fact(myjobETLDW, joinVendPed,"Fact_Venda");
		load_Fact.loadAddAllAttributesFromInput(false);
		
		
	    load_Fact.addParamDimension(load_DimProduct,"CODIGO","ES001_CODIGO","DIM_PRODUTO_FK");
	    load_Fact.addParamDimension(load_Dim2,"ID","TB001_ID","DIM_CLIENTE_FK");
	    load_Fact.addParamDimension(load_DimTempo,"DATA","DATA","DIM_TEMPO_FK");
	    
	    load_Fact.addMapperMeasure("QUANTIDADE_ATENDIDO","QUANTIDADE");
	    load_Fact.addMapperMeasure("PESO_TOTAL_ATENDIDO","PESO");
	    load_Fact.addMapperMeasure("VALOR_TOTAL_ATENDIDO","VALOR_PEDIDO");
	    load_Fact.addMapperMeasure("DESCONTO","VALOR_DESCONTO");
	    load_Fact.addMapperMeasure("VALOR_TOTAL","VALOR_TOTAL");
	        
		
				
		// <<<<<<<<<<<<<<<<<<<<<<<<<<<<  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
				
	}

	
	
	
}
