package frametl4CostAccount;

import java.sql.SQLException;
import java.util.List;


import frametl.FramETL;
import metadata_inventory.SchemaData;
import metadata_inventory.Attribute.tp_column_type;
import metadata_inventory_repository.AbstractRecordSet;
import metadata_inventory_repository.RecordSetOutput;
import metadata_model_general.Job;
import metadata_model_mechanism.AbstractMechanism;
import metadata_model_mechanism.AbstractMechanismUnary;
import metadata_model_mechanism.ListOfMapper;
import metadata_model_mechanism.Mapper;
import metadata_model_mechanism.Params;
import metadata_model_mechanism.RowControl;
import metadata_model_mechanisms_common.*;


public class CostProration extends AbstractMechanismUnary {

	
	private static String C_COSTCONSUMER = "COST_DRIVER";  
	private static String C_COSTDRIVER   = "COST_CONSUMER";

	
	
	public  CostProration(Job jobOwner, String name,String definition) {
		super(jobOwner, name, definition);

	}
	
	public  CostProration(Job jobOwner, AbstractMechanism transInput) {
		super(jobOwner, "", "",transInput);

	}
	
	
	// Construtor do Mecanismo, passando os Registros de Custos Indiretos 
	public  CostProration(Job jobOwner, String name,String definition, AbstractMechanism transInput) {
		super(jobOwner, name, definition, transInput, null);

	}
	
	
	Params myParamCostConsumer = null;
	Params myParamCostDriver = null;
	
	RecordSetOutput rsCostDriver = null;
	RecordSetOutput rsCostConsumer = null;
	
	
	Aggregation transfSum = null;


	
	
	// Define Paramtros com Direcionadores de Custo
	public void setParamCostDriver(AbstractMechanism mechanismCostDriver, String costDriverAtribute) {			
		Params param = new Params();
		
		param.addItem(this.C_COSTDRIVER);
		param.addItem(costDriverAtribute);
		
		param.setMechanism(mechanismCostDriver);
		
		this.addParam(param);		
	}
	
	
	
	// Define Paramtros com Consumidores de Custo
	public void setParamCostConsumer(AbstractMechanism mechanismCostConsumer, String costCostValueAtribute) {			
		Params param = new Params();
				
		param.addItem(this.C_COSTCONSUMER);
		param.addItem(costCostValueAtribute);
		param.setMechanism(mechanismCostConsumer);
				
		this.addParam(param);		
	}
	
	

	
	boolean lHasRecord = false;

	
	
	@Override
	public void onStart(AbstractMechanism transf) {
		
		myParamCostDriver = this.params.findParamByValue(this.C_COSTDRIVER, 0);
		
		transfSum = new Aggregation(this.getInternalJob(), myParamCostDriver.getMechanism());
		transfSum.loadAddAllAttributesFromInput(false);		

		Mapper map = transfSum.addMapper(myParamCostDriver.getMechanism().columnDataByName(myParamCostDriver.getItem(1)));		
		transfSum.addParam(map,Aggregation.FUNCTION_SUM);		
		transfSum.execute(null);		
		this.transfSum.getRecordSetOutput().firstRow(true);
		
	}
	
	
	
		
	@Override
	public void forEachInputtRow(ListOfMapper mappers, RowControl rowControl) {
				
		myParamCostConsumer = this.params.findParamByValue(this.C_COSTCONSUMER, 0);		
		rsCostConsumer = myParamCostConsumer.getMechanism().getRecordSetOutput();
						
		if (rsCostConsumer.firstRow(true));
		do {
			try {						
				
				this.storeOutPutRow();				
				
			} catch (Exception e) {
				e.printStackTrace();
			}
						
		} while (rsCostConsumer.nextRow(true));
				
		rowControl.status = RowControl.tp_status.REJECTED;			 
	}



	@Override
	public void onMapping(Mapper currentMap) {
							
		
		if (currentMap.getColumn_in().getColumn_type()  ==  tp_column_type.VIRTUAL) 			
			currentMap.getColumn_out().setData_value(rsCostConsumer.getColunm(currentMap.getColumn_in().getName()).getData_value());
		
		if (currentMap.getColumn_in().getName().equalsIgnoreCase(myParamCostConsumer.getItem(1))) {
						
			Double nCustDriverSum = Double.parseDouble(this.transfSum.getRecordSetOutput().getColunm("AREA").getData_value());		
			System.out.println("area total:" + nCustDriverSum);
					
			Double nArea = 0.0;				
			try {
				nArea = Double.parseDouble(rsCostConsumer.getColunm(myParamCostDriver.getItem(1)).getData_value());
								
				System.out.println("area do Viveiro:" + nArea);
				
			} catch (Exception e) {

				e.printStackTrace();
			}		
			Double nValor = Double.parseDouble(currentMap.getColumn_in().getData_value());		
			Double nRateio = (nValor/nCustDriverSum) * nArea;				
			String cRateio = Double.toString(nRateio);
			
			currentMap.getColumn_out().setData_value(cRateio);
		}
	}

	
	
	@Override
	public void onFinish(AbstractMechanism transf) {		
	}


	@Override
	public void init() {		
	}



	@Override
	public void onOpenDataSet() {		
	}
	
	
		
}
