package frametl4StarDW;

import java.util.ArrayList;
import java.util.List;


import metadata_inventory.Attribute;
import metadata_inventory.Attribute.tp_data_type;
import metadata_model_general.Job;
import metadata_model_mechanism.AbstractMechanism;
import metadata_model_mechanism.ListOfMapper;
import metadata_model_mechanism.Mapper;
import metadata_model_mechanism.Params;
import metadata_model_mechanism.RowControl;
import metadata_model_mechanisms_common.*;


import frametl.FramETL;


public class LoaderStarSchema_Dimension extends Loader  {


	private List<TableSource> transf_TableSource = new ArrayList<TableSource>();
	
	private String dw_surrogate_key = "";
	private String stg_surrogate_key = "";

	
	
	public LoaderStarSchema_Dimension(Job jobOwner, AbstractMechanism transfTableSource1,String dw_Dimension, String dw_surrogate_key) {
		
		super(jobOwner, transfTableSource1, dw_Dimension);
						
		this.loadAddAllAttributesFromInput(false);
		
		this.dw_surrogate_key = dw_surrogate_key;
		this.stg_surrogate_key = this.getTransfInput().get(0).concatsurrogateKeyName();
		
		this.addMapper(this.getTransfInput().get(0).columnDataByName(this.stg_surrogate_key), this.columnTarget(this.dw_surrogate_key));		
	}

	
	

	

	
	
	
	@Override
	public void onOpenDataSet() {
		
		

		for (int x = 0; x < this.transf_TableSource.size(); x++) {	
			
			TableSource normalSource = this.transf_TableSource.get(x);
			
			this.getInputSqlElements().addJoinRelation(normalSource.getTransf_RelationFK().getRecordSetOutput().getSchemaData().getName(),normalSource.getNatural_FK(),normalSource.getTransfTableSource().getRecordSetOutput().getSchemaData().getName(),normalSource.getNatural_PK());
			
		}		
	}
	
	
	
	
	@Override
	public void forEachInputtRow(ListOfMapper mappers, RowControl rowControl) {
		// TODO Auto-generated method stub
		
	}

	

	@Override
	public void onMapping(Mapper currentMap) {
		// TODO Auto-generated method stub
		

		    
		
	}

	
	
	
	

	
	/*
	
	public Params addParamTableSource(String schemaSource, String natural_PK, String natural_FK) {		
		
		Params param = new Params();
		
		
		Extractor extracSource = new Extractor(this.getInternalJob(),schemaSource);	
		param.setMechanism(extracSource);
		
		TableSource tableSource = new TableSource(extracSource, natural_PK, this.getTransfInput(0), natural_FK);
		this.transf_TableSource.add(tableSource);
		
		this.addParam(param);
		
		return param;
	}
	
		
	public Params addParamTableSource(String schemaSource, String natural_PK, String schemaSourceSecondary, String natural_FK) {		
		
		Params param = new Params();
		
		Extractor extracSource = new Extractor(this.getInternalJob(),schemaSource);	
		param.setMechanism(extracSource);
		
		Extractor extracSource2 = new Extractor(this.getInternalJob(),schemaSource);	
		
		
		TableSource tableSource = new TableSource(extracSource, natural_PK, extracSource2, natural_FK);
		this.transf_TableSource.add(tableSource);
		
		this.addParam(param);
		
		return param;
	}
	*/
	

///*  antigo
 
  	public Params addParamTableSource(AbstractMechanism transfTableSource, String natural_PK, String natural_FK) {		
		
		Params param = new Params();
		
		TableSource tableSource = new TableSource(transfTableSource, natural_PK, this.getTransfInput(0), natural_FK);
		this.transf_TableSource.add(tableSource);
		
		this.addParam(param);
		
		return param;
	}
	
	
	public Params addParamTableSource(AbstractMechanism transfTableSource, String natural_PK, AbstractMechanism transf_RelationFK, String natural_FK) {		
		
		Params param = new Params();
		
		TableSource tableSource = new TableSource(transfTableSource, natural_PK, transf_RelationFK, natural_FK);
		this.transf_TableSource.add(tableSource);
		
		this.addParam(param);
				
		return param;
	}
//	*/
	
	

	public AbstractMechanism getTransfSource(int index) {
		return this.transf_TableSource.get(index).getTransfTableSource();
	}
	
	public String getTransfSourcePK(int index) {
		return this.transf_TableSource.get(index).getNatural_PK();
	}
	
	public String getTransfSourceFK(int index) {
		return this.transf_TableSource.get(index).getNatural_FK();
	}
	
	

	


	@Override
	public void onFinish(AbstractMechanism transf) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void onStart(AbstractMechanism transf) {
		// TODO Auto-generated method stub
				
		//this.getInternalJob().perform();
		
		/*
		DimStarSchema myDim = this.transf_Dimensions.get(0);	
		Filter transfJ = new Filter(this.getFramETLInstance(),"SUBTRANSF_1","Join sources",myDim.getTransfSource(0)); // "STG_CV002"				
		System.out.println("Sub Transformation Created. " + transfJ.getName());		
		this.addSubTransformation(transfJ);		
		this.performSubTransformation();
			*/
				
		/*
		Join transfJ = new Join(this.getFramETLInstance(),"SUBTRANSF_1","Join sources",myDim.getTransfSource(0),myDim.getTransfSource(0)); // "STG_CV002"		
		transfJ.setParam(myDim.getTransfSourcePK(0),myDim.getTransfSourceFK(0));
		System.out.println("Sub Transformation Created. " + transfJ.getName());		
		this.addSubTransformation(transfJ);		
		this.performSubTransformation();
		*/
		
	}




	
	public void addMapperAttribute(AbstractMechanism transfSource, String attribute_source, String attribute_Dim) {
		
		
		this.addMapper(new Attribute(attribute_source,transfSource.getRecordSetOutput(),tp_data_type.STRING),this.columnTarget(attribute_Dim));
	}

	
	public void addMapperAttribute(String attribute_source, String attribute_Dim) {
		
		this.addMapper(this.getTransfInput(0).columnDataByName(attribute_source),this.columnTarget(attribute_Dim));
	}


	public void addMapperAttribute(String attribute) {
		
		this.addMapper(this.getTransfInput(0).columnDataByName(attribute),this.columnTarget(attribute));
	}




	public String getDw_surrogate_key() {
		return dw_surrogate_key;
	}



	public String getStg_surrogate_key() {
		return stg_surrogate_key;
	}



	@Override
	public void init() {
		// TODO Auto-generated method stub
		//this.setType(tp_transfUnary.ROWLEVEL);
	}
		


}
