package frametl4StarDW;


import frametl.FramETL;

import java.util.ArrayList;
import java.util.List;

import metadata_inventory.Attribute;
import metadata_inventory.Attribute.tp_data_type;
import metadata_model_general.Job;
import metadata_model_mechanism.AbstractMechanism;
import metadata_model_mechanism.ListOfMapper;
import metadata_model_mechanism.Mapper;
import metadata_model_mechanism.RowControl;
import metadata_model_mechanisms_common.*;

public class LoaderStarSchema_Fact extends Loader {

	//private AbstractTransformation transf_Fact = null;
	
	private List<LoaderStarSchema_Dimension> transf_Dimensions = new ArrayList<LoaderStarSchema_Dimension>();
	
	private List<String> attr_surrogate_keys = new ArrayList<String>();
	private List<String> attr_natural_pk = new ArrayList<String>();	
	private List<String> attr_natural_fk = new ArrayList<String>();
			
	private List<String> attr_measures = new ArrayList<String>();	
	private List<String> attr_measures_source = new ArrayList<String>();
		
	public LoaderStarSchema_Fact( Job jobOwner, AbstractMechanism transfSource_Fact,String dw_Fact) {
		super(jobOwner, transfSource_Fact, dw_Fact);
		
		this.loadAddAllAttributesFromInput(false);
		// TODO Auto-generated constructor stub
	}


	@Override
	public void init() {
		// TODO Auto-generated method stub
		//this.setType(tp_transfUnary.ROWLEVEL);
	}
	
	
	public void addParamDimension(LoaderStarSchema_Dimension dimension, String natural_pk, String natural_fk, String dw_surrogate_key_fk) {	

		transf_Dimensions.add(dimension);	
		
		this.attr_surrogate_keys.add(dw_surrogate_key_fk);
		this.attr_natural_pk.add(natural_pk);
		this.attr_natural_fk.add(natural_fk);
		
		this.addMapper(new Attribute(dimension.getStg_surrogate_key(),dimension.getRecordSetInput(),tp_data_type.INTEGER), this.columnTarget(dw_surrogate_key_fk));
	}
	
	

	public void addMapperMeasure(String attr_source,String attr_measure) {
		this.attr_measures.add(attr_measure);
		this.attr_measures_source.add(attr_source);
				
		this.addMapper(this.getTransfInput().get(0).columnDataByName(attr_source),this.columnTarget(attr_measure));
	}
	
	
	@Override
	public void onOpenDataSet() {
		
		for (int x = 0; x < this.transf_Dimensions.size(); x++) {	
			
			//this.getInputSqlElements().addJoinRelation(Integer.parseInt(this.params.get(x).getItem(0)),this.params.get(x).getItem(1),Integer.parseInt(this.params.get(x).getItem(2)),this.params.get(x).getItem(3));
			
			AbstractMechanism transfSource = this.transf_Dimensions.get(x);
			
			this.getInputSqlElements().addJoinRelation(this.getRecordSetInput().getSchemaData().getName(),attr_natural_fk.get(x), transfSource.getRecordSetInput().getSchemaData().getName(),attr_natural_pk.get(x));
			
		}

	}


	@Override
	public void onFinish(AbstractMechanism transf) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void onStart(AbstractMechanism transf) {
		// TODO Auto-generated method stub
			
		/*
		DimStarSchema myDim = this.transf_Dimensions.get(0);	
		Filter transfJ = new Filter(this.getFramETLInstance(),"SUBTRANSF_1","Join sources",myDim.getTransfSource(0)); // "STG_CV002"				
		System.out.println("Sub Transformation Created. " + transfJ.getName());		
		this.addSubTransformation(transfJ);		
		this.performSubTransformation();
		*/
				
		/*
		Join transfJ = new Join(this.getFramETLInstance(),"SUBTRANSF_1","Join sources",myDim.getTransfSource(0),myDim.getTransfSource(0)); // "STG_CV002"		
		transfJ.setParam(myDim.getTransfSourcePK(0),myDim.getTransfSourceFK(0));
		System.out.println("Sub Transformation Created. " + transfJ.getName());		
		this.addSubTransformation(transfJ);		
		this.performSubTransformation();
		*/
		
	}


	@Override
	public void forEachInputtRow(ListOfMapper mappers, RowControl rowControl) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void onMapping(Mapper currentMap) {
		// TODO Auto-generated method stub
		
	}



	
	public String getAttr_surrogate_key(int index) {
		return attr_surrogate_keys.get(index);
	}


	
	
	public String getAttr_measure(int index) {
		return attr_measures.get(index);
	}

	
	public String getAttr_measure_source(int index) {
		return attr_measures_source.get(index);
	}




	


}
